//+------------------------------------------------------------------+
//|                                       STRONG_WEAK_CURRENCIES.mq4 |
//|                                                 Copyright  2012 |
//|                                                           Tomcat |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012,Tomcat."
#property link      "Tomcat"

#property indicator_separate_window
#include <WinUser32.mqh>
#include <stdlib.mqh>
#property indicator_buffers 8
#property indicator_level1  0

#property indicator_color1 Green
#property indicator_color2 Blue
#property indicator_color3 Aqua
#property indicator_color4 Ivory
#property indicator_color5 Yellow
#property indicator_color6 Red
#property indicator_color7 Maroon
#property indicator_color8 DarkGray

color indicator_clr1 = Green;         //USD
color indicator_clr2 = Blue;          //EUR 
color indicator_clr3 = Aqua;          //GBP
color indicator_clr4 = Ivory;         //CHF
color indicator_clr5 = Yellow;        //AUD
color indicator_clr6 = Red;           //CAD
color indicator_clr7 = Maroon;        //JPY
color indicator_clr8 = DarkGray;      //NZD
//---- indicator parameters
extern int TimeFrame  =0;
bool       recalculate  ;
bool       Init       =true;
bool       exit       = false;
//---- indicator buffers
double     USD_Buffer[];
double     EUR_Buffer[];
double     GBP_Buffer[];
double     CHF_Buffer[];
double     AUD_Buffer[];
double     CAD_Buffer[];
double     JPY_Buffer[];
double     NZD_Buffer[];

double     BASKET_BUFFER[];

double close_EURUSD[];
double close_GBPUSD[];
double close_USDCHF[];
double close_AUDUSD[];
double close_USDCAD[];
double close_USDJPY[];
double close_NZDUSD[];
double close_EURGBP[];
double close_EURCHF[];
double close_EURAUD[];
double close_EURCAD[];
double close_EURJPY[];
double close_EURNZD[];
double close_GBPCHF[];
double close_GBPAUD[];
double close_GBPCAD[];
double close_GBPJPY[];
double close_GBPNZD[];
double close_AUDCHF[];
double close_CADCHF[];
double close_CHFJPY[];
double close_NZDCHF[];
double close_AUDCAD[];
double close_AUDJPY[];
double close_AUDNZD[];
double close_CADJPY[];
double close_NZDCAD[];
double close_NZDJPY[];

string short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for DataWindow and indicator subwindow label 
    IndicatorBuffers(8);
    SetIndexBuffer(0,USD_Buffer);   
    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,indicator_color1);
    SetIndexLabel(0,"USD");
    SetIndexDrawBegin(0,TimeFrame);
    SetIndexBuffer(1,EUR_Buffer);
    SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,indicator_color2);
    SetIndexLabel(1,"EUR");
    SetIndexDrawBegin(1,TimeFrame);   
    SetIndexBuffer(2,GBP_Buffer);
    SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,indicator_color3);
    SetIndexLabel(2,"GBP");
    SetIndexDrawBegin(2,TimeFrame);    
    SetIndexBuffer(3,CHF_Buffer);
    SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1,indicator_color4); 
    SetIndexLabel(3,"CHF");
    SetIndexDrawBegin(3,TimeFrame);     
    SetIndexBuffer(4,AUD_Buffer);
    SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,indicator_color5); 
    SetIndexLabel(4,"AUD");
    SetIndexDrawBegin(4,TimeFrame);   
    SetIndexBuffer(5,CAD_Buffer);
    SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1,indicator_color6); 
    SetIndexLabel(5,"CAD");
    SetIndexDrawBegin(5,TimeFrame);    
    SetIndexBuffer(6,JPY_Buffer);
    SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,indicator_color7); 
    SetIndexLabel(6,"JPY");
    SetIndexDrawBegin(6,TimeFrame);   
    SetIndexBuffer(7,NZD_Buffer);
    SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,1,indicator_color8); 
    SetIndexLabel(7,"NZD");
    SetIndexDrawBegin(7,TimeFrame);    
    short_name="STRONG_WEAK_CURRENCIES("+TimeFrame+")";
    IndicatorShortName(short_name);
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  Comment("");
  return (0);  
  }
  
//+------------------------------------------------------------------+
//| STRONG_WEAK_CURRENCIES                                           |
//+------------------------------------------------------------------+
int start()
  {
   if(exit)
       return(0);
 //---- amount not changed bars after last call of the indicator --+      
  int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(recalculate)
     {
      int limit = Bars;
      recalculate = false;
     }
   else limit = Bars - counted_bars;
   //---- set values of candles -------------------------------------+
   for(int i=limit; i>=0; i--)
     {
       datetime time_bar = Time[i];   
       //int bar_no = iBarShift(symbol, Period(), time_bar, false);
     
   //---- set values of candles -------------------------------------+  
   int bar_no_EURUSD = iBarShift("EURUSD", Period(), time_bar, false); 
   close_EURUSD[i]=iClose("EURUSD",Period(),bar_no_EURUSD);
   
   int bar_no_GBPUSD = iBarShift("GBPUSD", Period(), time_bar, false);
   close_GBPUSD[i]=iClose("GBPUSD",Period(),bar_no_GBPUSD);
   
   int bar_no_USDCHF = iBarShift("USDCHF", Period(), time_bar, false);   
   close_USDCHF[i]=iClose("USDCHF",Period(),bar_no_USDCHF);
   
   int bar_no_AUDUSD = iBarShift("AUDUSD", Period(), time_bar, false);
   close_AUDUSD[i]=iClose("AUDUSD",Period(),bar_no_AUDUSD);
   
   int bar_no_USDCAD = iBarShift("USDCAD", Period(), time_bar, false);
   close_USDCAD[i]=iClose("USDCAD",Period(),bar_no_USDCAD);
   
   int bar_no_USDJPY = iBarShift("USDJPY", Period(), time_bar, false);
   close_USDJPY[i]=iClose("USDJPY",Period(),bar_no_USDJPY);
   
   int bar_no_NZDUSD = iBarShift("NZDUSD", Period(), time_bar, false);
   close_NZDUSD[i]=iClose("NZDUSD",Period(),bar_no_NZDUSD);
   
   int bar_no_EURGBP = iBarShift("EURGBP", Period(), time_bar, false);
   close_EURGBP[i]=iClose("EURGBP",Period(),bar_no_EURGBP);
   
   int bar_no_EURCHF = iBarShift("EURCHF", Period(), time_bar, false);
   close_EURCHF[i]=iClose("EURCHF",Period(),bar_no_EURCHF);
   
   int bar_no_EURAUD = iBarShift("EURAUD", Period(), time_bar, false);
   close_EURAUD[i]=iClose("EURAUD",Period(),bar_no_EURAUD);
   
   int bar_no_EURCAD = iBarShift("EURCAD", Period(), time_bar, false);
   close_EURCAD[i]=iClose("EURCAD",Period(),bar_no_EURCAD);
   
   int bar_no_EURJPY = iBarShift("EURJPY", Period(), time_bar, false);
   close_EURJPY[i]=iClose("EURJPY",Period(),bar_no_EURJPY);
   
   int bar_no_EURNZD = iBarShift("EURUSD", Period(), time_bar, false);
   close_EURNZD[i]=iClose("EURNZD",Period(),bar_no_EURNZD);
   
   int bar_no_GBPCHF = iBarShift("GBPCHF", Period(), time_bar, false);
   close_GBPCHF[i]=iClose("GBPCHF",Period(),bar_no_GBPCHF);
   
   int bar_no_GBPAUD = iBarShift("GBPAUD", Period(), time_bar, false);
   close_GBPAUD[i]=iClose("GBPAUD",Period(),bar_no_GBPAUD);
   
   int bar_no_GBPCAD = iBarShift("GBPCAD", Period(), time_bar, false);
   close_GBPCAD[i]=iClose("GBPCAD",Period(),bar_no_GBPCAD);
   
   int bar_no_GBPJPY = iBarShift("GBPJPY", Period(), time_bar, false);
   close_GBPJPY[i]=iClose("GBPJPY",Period(),bar_no_GBPJPY);
   
   int bar_no_GBPNZD = iBarShift("GBPNZD", Period(), time_bar, false);
   close_GBPNZD[i]=iClose("GBPNZD",Period(),bar_no_GBPNZD);
   
   int bar_no_AUDCHF = iBarShift("AUDCHF", Period(), time_bar, false);
   close_AUDCHF[i]=iClose("AUDCHF",Period(),bar_no_AUDCHF);
   
   int bar_no_CADCHF = iBarShift("CADCHF", Period(), time_bar, false);
   close_CADCHF[i]=iClose("CADCHF",Period(),bar_no_CADCHF);
   
   int bar_no_CHFJPY = iBarShift("CHFJPY", Period(), time_bar, false);
   close_CHFJPY[i]=iClose("CHFJPY",Period(),bar_no_CHFJPY);
   
   int bar_no_NZDCHF = iBarShift("NZDCHF", Period(), time_bar, false);
   close_NZDCHF[i]=iClose("NZDCHF",Period(),bar_no_NZDCHF);
   
   int bar_no_AUDCAD = iBarShift("AUDCAD", Period(), time_bar, false);
   close_AUDCAD[i]=iClose("AUDCAD",Period(),bar_no_AUDCAD);
   
   int bar_no_AUDJPY = iBarShift("AUDJPY", Period(), time_bar, false);
   close_AUDJPY[i]=iClose("AUDJPY",Period(),bar_no_AUDJPY);
   
   int bar_no_AUDNZD = iBarShift("AUDNZD", Period(), time_bar, false);
   close_AUDNZD[i]=iClose("AUDNZD",Period(),bar_no_AUDNZD);
   
   int bar_no_CADJPY = iBarShift("CADJPY", Period(), time_bar, false);
   close_CADJPY[i]=iClose("CADJPY",Period(),bar_no_CADJPY);
   
   int bar_no_NZDCAD = iBarShift("NZDCAD", Period(), time_bar, false);
   close_NZDCAD[i]=iClose("NZDCAD",Period(),bar_no_NZDCAD);
   
   int bar_no_NZDJPY = iBarShift("NZDJPY", Period(), time_bar, false);
   close_NZDJPY[i]=iClose("NZDJPY",Period(),bar_no_NZDJPY);
   //---
   BASKET_BUFFER[i]=(close_EURUSD[i]+close_GBPUSD[i]+close_USDCHF[i]+close_AUDUSD[i]+close_USDCAD[i]+close_USDJPY[i]+close_NZDUSD[i]+
   close_EURGBP[i]+close_EURCHF[i]+close_EURAUD[i]+close_EURCAD[i]+close_EURJPY[i]+close_EURNZD[i]+close_GBPCHF[i]+close_GBPAUD[i]+
   close_GBPCAD[i]+close_GBPJPY[i]+close_GBPNZD[i]+close_AUDCHF[i]+close_CADCHF[i]+close_CHFJPY[i]+close_NZDCHF[i]+close_AUDCAD[i]+
   close_AUDJPY[i]+close_AUDNZD[i]+close_CADJPY[i]+close_NZDCAD[i]+close_NZDJPY[i] )/28 ;
   //---
   USD_Buffer[i]=((close_EURUSD[i]+close_GBPUSD[i]+close_USDCHF[i]+close_AUDUSD[i]+close_USDCAD[i]+close_USDJPY[i]+close_NZDUSD[i])/7)/BASKET_BUFFER[i];   
   EUR_Buffer[i]=((close_EURUSD[i]+close_EURGBP[i]+close_EURCHF[i]+close_EURAUD[i]+close_EURCAD[i]+close_EURJPY[i]+close_EURNZD[i])/7)/BASKET_BUFFER[i];
   GBP_Buffer[i]=((close_GBPUSD[i]+close_EURGBP[i]+close_GBPCHF[i]+close_GBPAUD[i]+close_GBPCAD[i]+close_GBPJPY[i]+close_GBPNZD[i])/7)/BASKET_BUFFER[i];   
   CHF_Buffer[i]=((close_USDCHF[i]+close_EURCHF[i]+close_GBPCHF[i]+close_AUDCHF[i]+close_CADCHF[i]+close_CHFJPY[i]+close_NZDCHF[i])/7)/BASKET_BUFFER[i];
   AUD_Buffer[i]=((close_AUDUSD[i]+close_EURAUD[i]+close_GBPAUD[i]+close_AUDCHF[i]+close_AUDCAD[i]+close_AUDJPY[i]+close_AUDNZD[i])/7)/BASKET_BUFFER[i];
   CAD_Buffer[i]=((close_USDCAD[i]+close_EURCAD[i]+close_GBPCAD[i]+close_CADCHF[i]+close_AUDCAD[i]+close_CADJPY[i]+close_NZDCAD[i])/7)/BASKET_BUFFER[i];
   JPY_Buffer[i]=((close_USDJPY[i]+close_EURJPY[i]+close_GBPJPY[i]+close_CHFJPY[i]+close_AUDJPY[i]+close_CADJPY[i]+close_NZDJPY[i])/7)/BASKET_BUFFER[i];
   NZD_Buffer[i]=((close_NZDUSD[i]+close_EURNZD[i]+close_GBPNZD[i]+close_NZDCHF[i]+close_AUDNZD[i]+close_NZDCAD[i]+close_NZDJPY[i])/7)/BASKET_BUFFER[i];  
 //---

  
//+------------------------------------------------------------------+
//| Write  Curr. & code color   text                                 |
//+------------------------------------------------------------------+    
    
 #define write_position 200
        
        ObjectCreate("USD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("USD","USD",12, "Arial Bold");
        ObjectSet("USD", OBJPROP_COLOR, Green);
        ObjectSet("USD", OBJPROP_CORNER, 0);
        ObjectSet("USD", OBJPROP_XDISTANCE, write_position);
        ObjectSet("USD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("EUR", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("EUR","EUR",12, "Arial Bold");
        ObjectSet("EUR", OBJPROP_COLOR, Blue );
        ObjectSet("EUR", OBJPROP_CORNER, 0);
        ObjectSet("EUR", OBJPROP_XDISTANCE, write_position+80);//40
        ObjectSet("EUR", OBJPROP_YDISTANCE, 3);

        ObjectCreate("GBP", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("GBP","GBP",12, "Arial Bold");
        ObjectSet("GBP", OBJPROP_COLOR, Aqua );
        ObjectSet("GBP", OBJPROP_CORNER, 0);
        ObjectSet("GBP", OBJPROP_XDISTANCE, write_position+160);//80
        ObjectSet("GBP", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("CHF", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("CHF","CHF",12, "Arial Bold");
        ObjectSet("CHF", OBJPROP_COLOR, Ivory);
        ObjectSet("CHF", OBJPROP_CORNER, 0);
        ObjectSet("CHF", OBJPROP_XDISTANCE, write_position+240);//120
        ObjectSet("CHF", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("AUD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("AUD","AUD",12, "Arial Bold");
        ObjectSet("AUD", OBJPROP_COLOR, Yellow);
        ObjectSet("AUD", OBJPROP_CORNER, 0);
        ObjectSet("AUD", OBJPROP_XDISTANCE, write_position+320);//160
        ObjectSet("AUD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("CAD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("CAD","CAD",12, "Arial Bold");
        ObjectSet("CAD", OBJPROP_COLOR, Red);
        ObjectSet("CAD", OBJPROP_CORNER, 0);
        ObjectSet("CAD", OBJPROP_XDISTANCE, write_position+400);//200
        ObjectSet("CAD", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("JPY", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("JPY","JPY",12, "Arial Bold");
        ObjectSet("JPY", OBJPROP_COLOR, Maroon );
        ObjectSet("JPY", OBJPROP_CORNER, 0);
        ObjectSet("JPY", OBJPROP_XDISTANCE, write_position+480);//240
        ObjectSet("JPY", OBJPROP_YDISTANCE, 3);
        
        ObjectCreate("NZD", OBJ_LABEL, WindowFind(short_name), 0, 0);
        ObjectSetText("NZD","NZD",12, "Arial Bold");
        ObjectSet("NZD", OBJPROP_COLOR, DarkGray);
        ObjectSet("NZD", OBJPROP_CORNER, 0);
        ObjectSet("NZD", OBJPROP_XDISTANCE, write_position+560);//280
        ObjectSet("NZD", OBJPROP_YDISTANCE, 3);
     }
    return(0); 
  }
//+------------------------------------------------------------------+